#!/usr/local/bin/python
# -*- coding: iso-8859-1 -*-

## Copyright 2005 by LivingLogic AG, Bayreuth/Germany.
## Copyright 2005 by Walter Drwald
##
## All Rights Reserved
##
## See orasql.py for the license


import sys

from ll import orasql


if __name__ == "__main__":
	import sys, optparse

	p = optparse.OptionParser(usage="usage: %prog [options] connectstring >output.sql")
	p.add_option("-v", "--verbose", dest="verbose", help="Give a progress report?", default=False, action="store_true")

	(options, args) = p.parse_args()
	if len(args) != 1:
		p.error("incorrect number of arguments")
		sys.exit(1)

	connection = orasql.connect(args[0])
	cursor = connection.cursor()

	for definition in cursor.iterobjects(mode="create", all=False):
		if options.verbose:
			msg = "%s: %s: %s %s" % (sys.argv[0], args[0], definition.type, definition.name)
			if definition.owner is not None:
				msg += " (%s)" % definition.owner
			if definition.owner is not None:
				msg += " (skipped)"
			print >>sys.stderr, msg
		if definition.owner is None:
			ddl = definition.createddl(cursor)
			if ddl.strip():
				print definition.createddl(cursor)
				print
